<?php
/**
 * Copyright © 2016 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */

namespace FiloBlu\Storelocator\Controller\Index;

/**
 * Responsible for loading page content.
 *
 * This is a basic controller that only loads the corresponding layout file. It may duplicate other such
 * controllers, and thus it is considered tech debt. This code duplication will be resolved in future releases.
 */
class StoreDetailsById extends \Magento\Framework\App\Action\Action
{
    protected $jsonResultFactory;
    protected $storeFactory;

    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
        \FiloBlu\Storelocator\Model\StoresFactory $storeFactory
    )
    {
        parent::__construct($context);
        $this->resultJsonFactory = $resultJsonFactory;
        $this->storeFactory = $storeFactory;
    }

    public function execute()
    {
        $params = $this->getRequest()->getParams();

        if ($params["ajax"] == 1 && $params["store_id"] && $this->getRequest()->isXmlHttpRequest()) {
            $resultJson = $this->resultJsonFactory->create();

            $model = $this->storeFactory->create()->load($params["store_id"]);
            $resultJson->setData($model->getData());

            return $resultJson;
        } else {
            return null;
        }
    }
}
